/* 
   IPX.C
   z knihy Fojtik-Valtr naskenoval R0B0
   2000
*/

#define DEBUG

#include <stdio.h>
#include <dos.h>
#include "ipx.h"

int IPXInitialize (void) 
{
	_AX = 0x7A00;
	geninterrupt(0x2F);
  _AL=!(_AL==0xff);
	return( _AL);
}

int IPXOpenSocket (int cislosoketu)
{
	_SI = 0;
	_DI = 0;
	_DX = cislosoketu;
	_AL = 0;
	_BX = 0;
	geninterrupt(0x7A);
	return(_AL);
}

int IPXCloseSocket ( WORD cislosoketu )
{
	_SI = 0;
	_DI = 0;
	_BX = 1;
	_DX = cislosoketu;
	geninterrupt(0x7A);
	return( _AL);
}

int GetLocalTarget(BYTE *networkAddress ,
			BYTE *immediateAddress ,
			int *transportTime)
{
	_DI = 0;
	_ES=FP_SEG(networkAddress);
	_SI=FP_OFF(networkAddress);
	_DI=FP_OFF(immediateAddress);
	_BX=2 ;
	geninterrupt(0x7A);
	*transportTime = _CX;
	return( _AL);
}

int IPXSendPacket(ECB *blok)
{
	_DI = 0;
	_ES=FP_SEG(blok);
	_SI=FP_OFF(blok);
	_BX=3;
	geninterrupt(0x7A);
	return(_AL);
}

int IPXListenForPacket(ECB *blok)
{
	/*_DI = 0;*/
	_ES=FP_SEG(blok);
	_SI=FP_OFF(blok);
	_BX=4;
	geninterrupt(0x7A);
	return(_AL);
}

void IPXScheduleIPXEvent(WORD DelayTime ,
		ECB *eventControlBlock)
{
	_DI = 0;
	_AX=DelayTime;
	_ES=FP_SEG(eventControlBlock);
	_SI=FP_OFF(eventControlBlock);
	_BX= 5; /* oznaC udalost AES pro IPX */
	geninterrupt(0x7A);
}

int IPXCancelEvent(ECB *blok)
{
	_DI = 0;
	_ES=FP_SEG(blok);
	_SI=FP_OFF(blok);
	_BX = 6;
	geninterrupt(0x7A);
	return(_AL);
}

void IPXScheduleSpecialEvent(WORD DelayTime ,
		ECB *eventControlBlock)
{
	_DI = 0;
	_AX=DelayTime;
	_ES=FP_SEG(eventControlBlock);
	_SI=FP_OFF(eventControlBlock);
	_BX = 7; /* ozna~ speci~lni ud5lost AES */
	geninterrupt(0x7A);
}

WORD GetIntervalMarker(void)
{
	_SI = 0;
	_DI = 0;
	_BX=8;
	geninterrupt(0x7A);
	return(_AX);
}

void IPXGetInternetworkAddress(BYTE *networkAddress)
{ /* zji`st~ni vlastni adresy */
	_DI = 0;
	_ES=FP_SEG(networkAddress);
	_SI=FP_OFF(networkAddress);
	_BX=9;
	geninterrupt(0x7A);
	return;
}

void IPXRelinquishControl(void)
{
	_SI = 0;
	_DI = 0;
	_BX=0x0A;
	geninterrupt(0x7A);
	return;
}

void DisconnectFromTarget(BYTE *networkAddress)
{
	_DI = 0;
	_ES=FP_SEG(networkAddress);
	_SI=FP_OFF(networkAddress);
	_BX=0x08;
	geninterrupt(0x7A);
	return;
}


BYTE BROADCAST[]={0xff,0xff,0xff,0xff,0xff,0xff};


WORD htonl(WORD h)
{
	_AX=h;
	asm {
		XCHG AL,AH
	}
	return _AX;
}

char *formatAddr(BYTE *a)
{
	static char buff[30];
	sprintf(buff,"%x:%x:%x:%x:%x:%x",*a,*(a+1),*(a+2),*(a+3),*(a+4),*(a+5));
	return(buff);
}
