/* p.h

	 Definicia protokolu P
	 Komunikacia na baze IPX protokolu
	 autor: Robert Trebula
	 kruzok SI 4
	 rok: 2000
*/

#define MYSOCKET 4831

#define UNIQUE 0
#define RESPONSE 1
#define ADDGROUPNAME 2
#define DELETENAME 3
#define DATA 4
#define SETUNIQUENAME 5
#define DELETENODE 6

typedef struct P_packetheader {
	char destination[10];
	char source[10];
	BYTE type;
	BYTE length;
} P_packetheader;

typedef struct P_packet{
	IPXHeader ipxh;
	P_packetheader ph;
	char body[255];
} P_packet;

typedef struct Name {
	char c[10];
	BYTE a[6];
	struct Name *next;
} Name;

int InitListenEcb(ECB *ecb);
int SendPacket(BYTE *dest, P_packet *packet);
P_packet *CheckListenEcb(ECB *ecb);
BYTE *GetHostByName(char *name);
int ParsePacket(P_packet *p);
int SendData(void);
int addName(Name *where,char *name,BYTE *addr);
int testUnique(char *name);
int UserInput(void);
int DeleteNode(BYTE *addr);
int InitIPX(void);
int deleteName(Name *where, char *name, BYTE *addr);
int isMyName(char *);
